Index: root_commands.c
===================================================================
--- root_commands.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ root_commands.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -1085,63 +1120,41 @@
 		if( strchr( CTYPES, channel[0] ) == NULL )
 		{
-			s = g_strdup_printf( "%c%s", CTYPES[0], channel );
+			s = g_strdup_printf( "#%s", channel );
 			g_free( channel );
 			channel = s;
-		}
-		
-		if( ( c = chat_add( irc, acc, cmd[3], channel ) ) )
-			irc_usermsg( irc, "Chatroom added successfully." );
-		else
+			
+			irc_channel_name_strip( channel );
+		}
+		
+		if( ( ic = irc_channel_new( irc, channel ) ) &&
+		    set_setstr( &ic->set, "type", "chat" ) &&
+		    set_setstr( &ic->set, "chat_type", "room" ) &&
+		    set_setstr( &ic->set, "account", cmd[2] ) &&
+		    set_setstr( &ic->set, "room", cmd[3] ) )
+		{
+			irc_usermsg( irc, "Chatroom successfully added." );
+		}
+		else
+		{
+			if( ic )
+				irc_channel_free( ic );
+			
 			irc_usermsg( irc, "Could not add chatroom." );
-		
+		}
 		g_free( channel );
 	}
-	else if( g_strcasecmp( cmd[1], "list" ) == 0 )
-	{
-		int i = 0;
-		
-		if( strchr( irc->umode, 'b' ) )
-			irc_usermsg( irc, "Chatroom list:" );
-		
-		for( c = irc->chatrooms; c; c = c->next )
-		{
-			irc_usermsg( irc, "%2d. %s(%s) %s, %s", i, c->acc->prpl->name,
-			                  c->acc->user, c->handle, c->channel );
-			
-			i ++;
-		}
-		irc_usermsg( irc, "End of chatroom list" );
-	}
-	else if( g_strcasecmp( cmd[1], "set" ) == 0 )
-	{
+	else if( g_strcasecmp( cmd[1], "with" ) == 0 )
+	{
+		irc_user_t *iu;
+		
 		MIN_ARGS( 2 );
 		
-		cmd_set_real( irc, cmd + 1, cmd_chat_set_findhead, NULL );
-	}
-	else if( g_strcasecmp( cmd[1], "del" ) == 0 )
-	{
-		MIN_ARGS( 2 );
-		
-		if( ( c = chat_get( irc, cmd[2] ) ) )
-		{
-			chat_del( irc, c );
-		}
-		else
-		{
-			irc_usermsg( irc, "Could not remove chat." );
-		}
-	}
-	else if( g_strcasecmp( cmd[1], "with" ) == 0 )
-	{
-		user_t *u;
-		
-		MIN_ARGS( 2 );
-		
-		if( ( u = user_find( irc, cmd[2] ) ) && u->ic && u->ic->acc->prpl->chat_with )
-		{
-			if( !u->ic->acc->prpl->chat_with( u->ic, u->handle ) )
+		if( ( iu = irc_user_by_name( irc, cmd[2] ) ) &&
+		    iu->bu && iu->bu->ic->acc->prpl->chat_with )
+		{
+			if( !iu->bu->ic->acc->prpl->chat_with( iu->bu->ic, iu->bu->handle ) )
 			{
 				irc_usermsg( irc, "(Possible) failure while trying to open "
-				                  "a groupchat with %s.", u->nick );
+				                  "a groupchat with %s.", iu->nick );
 			}
 		}
@@ -1151,4 +1164,11 @@
 		}
 	}
+	else if( g_strcasecmp( cmd[1], "list" ) == 0 ||
+	         g_strcasecmp( cmd[1], "set" ) == 0 ||
+	         g_strcasecmp( cmd[1], "del" ) == 0 )
+	{
+		irc_usermsg( irc, "Warning: The \002chat\002 command was mostly replaced with the \002channel\002 command." );
+		cmd_channel( irc, cmd );
+	}
 	else
 	{
@@ -1157,25 +1177,116 @@
 }
 
+static void cmd_group( irc_t *irc, char **cmd )
+{
+	GSList *l;
+	int len;
+	
+	len = strlen( cmd[1] );
+	if( g_strncasecmp( cmd[1], "list", len ) == 0 )
+	{
+		int n = 0;
+		
+		if( strchr( irc->umode, 'b' ) )
+			irc_usermsg( irc, "Group list:" );
+		
+		for( l = irc->b->groups; l; l = l->next )
+		{
+			bee_group_t *bg = l->data;
+			irc_usermsg( irc, "%d. %s", n ++, bg->name );
+		}
+		irc_usermsg( irc, "End of group list" );
+	}
+	else
+	{
+		irc_usermsg( irc, "Unknown command: %s %s. Please use \x02help commands\x02 to get a list of available commands.", "group", cmd[1] );
+	}
+}
+
+static void cmd_transfer( irc_t *irc, char **cmd )
+{
+	GSList *files = irc->file_transfers;
+	enum { LIST, REJECT, CANCEL };
+	int subcmd = LIST;
+	int fid;
+
+	if( !files )
+	{
+		irc_usermsg( irc, "No pending transfers" );
+		return;
+	}
+
+	if( cmd[1] && ( strcmp( cmd[1], "reject" ) == 0 ) )
+	{
+		subcmd = REJECT;
+	}
+	else if( cmd[1] && ( strcmp( cmd[1], "cancel" ) == 0 ) && 
+		 cmd[2] && ( sscanf( cmd[2], "%d", &fid ) == 1 ) )
+	{
+		subcmd = CANCEL;
+	}
+
+	for( ; files; files = g_slist_next( files ) )
+	{
+		file_transfer_t *file = files->data;
+		
+		switch( subcmd ) {
+		case LIST:
+			if ( file->status == FT_STATUS_LISTENING )
+				irc_usermsg( irc, 
+					"Pending file(id %d): %s (Listening...)", file->local_id, file->file_name);
+			else 
+			{
+				int kb_per_s = 0;
+				time_t diff = time( NULL ) - file->started ? : 1;
+				if ( ( file->started > 0 ) && ( file->bytes_transferred > 0 ) )
+					kb_per_s = file->bytes_transferred / 1024 / diff;
+					
+				irc_usermsg( irc, 
+					"Pending file(id %d): %s (%10zd/%zd kb, %d kb/s)", file->local_id, file->file_name, 
+					file->bytes_transferred/1024, file->file_size/1024, kb_per_s);
+			}
+			break;
+		case REJECT:
+			if( file->status == FT_STATUS_LISTENING )
+			{
+				irc_usermsg( irc, "Rejecting file transfer for %s", file->file_name );
+				imcb_file_canceled( file->ic, file, "Denied by user" );
+			}
+			break;
+		case CANCEL:
+			if( file->local_id == fid )
+			{
+				irc_usermsg( irc, "Canceling file transfer for %s", file->file_name );
+				imcb_file_canceled( file->ic, file, "Canceled by user" );
+			}
+			break;
+		}
+	}
+}
+
+/* IMPORTANT: Keep this list sorted! The short command logic needs that. */
 const command_t commands[] = {
+	{ "account",        1, cmd_account,        0 },
+	{ "add",            2, cmd_add,            0 },
+	{ "allow",          1, cmd_allow,          0 },
+	{ "blist",          0, cmd_blist,          0 },
+	{ "block",          1, cmd_block,          0 },
+	{ "channel",        1, cmd_channel,        0 },
+	{ "chat",           1, cmd_chat,           0 },
+	{ "drop",           1, cmd_drop,           0 },
+	{ "ft",             0, cmd_transfer,       0 },
+	{ "group",          1, cmd_group,          0 },
 	{ "help",           0, cmd_help,           0 }, 
 	{ "identify",       1, cmd_identify,       0 },
+	{ "info",           1, cmd_info,           0 },
+	{ "no",             0, cmd_yesno,          0 },
+	{ "qlist",          0, cmd_qlist,          0 },
 	{ "register",       1, cmd_register,       0 },
-	{ "drop",           1, cmd_drop,           0 },
-	{ "account",        1, cmd_account,        0 },
-	{ "add",            2, cmd_add,            0 },
-	{ "info",           1, cmd_info,           0 },
+	{ "remove",         1, cmd_remove,         0 },
 	{ "rename",         2, cmd_rename,         0 },
-	{ "remove",         1, cmd_remove,         0 },
-	{ "block",          1, cmd_block,          0 },
-	{ "allow",          1, cmd_allow,          0 },
 	{ "save",           0, cmd_save,           0 },
 	{ "set",            0, cmd_set,            0 },
+	{ "transfer",       0, cmd_transfer,       0 },
 	{ "yes",            0, cmd_yesno,          0 },
-	{ "no",             0, cmd_yesno,          0 },
-	{ "blist",          0, cmd_blist,          0 },
-	{ "nick",           1, cmd_nick,           0 },
-	{ "qlist",          0, cmd_qlist,          0 },
-	{ "join_chat",      2, cmd_join_chat,      0 },
-	{ "chat",           1, cmd_chat,           0 },
 	{ NULL }
 };
Index: set.c
===================================================================
--- set.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ set.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -29,5 +29,5 @@
 char *SET_INVALID = "nee";
 
-set_t *set_add( set_t **head, char *key, char *def, set_eval eval, void *data )
+set_t *set_add( set_t **head, const char *key, const char *def, set_eval eval, void *data )
 {
 	set_t *s = set_find( head, key );
@@ -63,5 +63,5 @@
 }
 
-set_t *set_find( set_t **head, char *key )
+set_t *set_find( set_t **head, const char *key )
 {
 	set_t *s = *head;
@@ -69,5 +69,6 @@
 	while( s )
 	{
-		if( g_strcasecmp( s->key, key ) == 0 )
+		if( g_strcasecmp( s->key, key ) == 0 ||
+		    ( s->old_key && g_strcasecmp( s->old_key, key ) == 0 ) )
 			break;
 		s = s->next;
@@ -77,5 +78,5 @@
 }
 
-char *set_getstr( set_t **head, char *key )
+char *set_getstr( set_t **head, const char *key )
 {
 	set_t *s = set_find( head, key );
@@ -87,5 +88,5 @@
 }
 
-int set_getint( set_t **head, char *key )
+int set_getint( set_t **head, const char *key )
 {
 	char *s = set_getstr( head, key );
@@ -101,5 +102,5 @@
 }
 
-int set_getbool( set_t **head, char *key )
+int set_getbool( set_t **head, const char *key )
 {
 	char *s = set_getstr( head, key );
@@ -111,5 +112,5 @@
 }
 
-int set_setstr( set_t **head, char *key, char *value )
+int set_setstr( set_t **head, const char *key, char *value )
 {
 	set_t *s = set_find( head, key );
@@ -150,5 +151,5 @@
 }
 
-int set_setint( set_t **head, char *key, int value )
+int set_setint( set_t **head, const char *key, int value )
 {
 	char s[24];	/* Not quite 128-bit clean eh? ;-) */
@@ -158,5 +159,5 @@
 }
 
-void set_del( set_t **head, char *key )
+void set_del( set_t **head, const char *key )
 {
 	set_t *s = *head, *t = NULL;
@@ -176,11 +177,12 @@
 		
 		g_free( s->key );
-		if( s->value ) g_free( s->value );
-		if( s->def ) g_free( s->def );
+		g_free( s->old_key );
+		g_free( s->value );
+		g_free( s->def );
 		g_free( s );
 	}
 }
 
-int set_reset( set_t **head, char *key )
+int set_reset( set_t **head, const char *key )
 {
 	set_t *s;
@@ -211,4 +213,19 @@
 {
 	return is_bool( value ) ? value : SET_INVALID;
+}
+
+char *set_eval_list( set_t *set, char *value )
+{
+	GSList *options = set->eval_data, *opt;
+	
+	for( opt = options; opt; opt = opt->next )
+		if( strcmp( value, opt->data ) == 0 )
+			return value;
+	
+	/* TODO: It'd be nice to show the user a list of allowed values,
+	         but we don't have enough context here to do that. May
+	         want to fix that. */
+	
+	return NULL;
 }
 
@@ -225,4 +242,5 @@
 }
 
+/*
 char *set_eval_ops( set_t *set, char *value )
 {
@@ -246,2 +264,3 @@
 	return value;
 }
+*/
Index: set.h
===================================================================
--- set.h	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ set.h	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -37,8 +37,5 @@
    from setting invalid values, you can write an evaluator function for
    every setting, which can check a new value and block it by returning
-   NULL, or replace it by returning a new value. See struct set.eval.
-   One thing that is really missing here is additional data for the
-   evaluator. This could be useful to add minimum and maximum values for
-   integers, for example. */
+   NULL, or replace it by returning a new value. See struct set.eval. */
 
 typedef char *(*set_eval) ( struct set *set, char *value );
@@ -54,4 +51,5 @@
 	
 	char *key;
+	char *old_key;  /* Previously known as; for smooth upgrades. */
 	char *value;
 	char *def;      /* Default value. If the set_setstr() function
@@ -65,36 +63,40 @@
 	                   this (yet?). */
 	
-	/* Eval: Returns SET_INVALID if the value is incorrect or exactly
-	   the passed value variable. When returning a corrected value,
-	   set_setstr() should be able to free() the returned string! */
+	/* Eval: Returns SET_INVALID if the value is incorrect, exactly
+	   the passed value variable, or a corrected value. In case of
+	   the latter, set_setstr() will free() the returned string! */
 	set_eval eval;
+	void *eval_data;
 	struct set *next;
 } set_t;
 
 /* Should be pretty clear. */
-set_t *set_add( set_t **head, char *key, char *def, set_eval eval, void *data );
+set_t *set_add( set_t **head, const char *key, const char *def, set_eval eval, void *data );
 
 /* Returns the raw set_t. Might be useful sometimes. */
-set_t *set_find( set_t **head, char *key );
+set_t *set_find( set_t **head, const char *key );
 
 /* Returns a pointer to the string value of this setting. Don't modify the
    returned string, and don't free() it! */
-G_MODULE_EXPORT char *set_getstr( set_t **head, char *key );
+G_MODULE_EXPORT char *set_getstr( set_t **head, const char *key );
 
 /* Get an integer. In previous versions set_getint() was also used to read
    boolean values, but this SHOULD be done with set_getbool() now! */
-G_MODULE_EXPORT int set_getint( set_t **head, char *key );
-G_MODULE_EXPORT int set_getbool( set_t **head, char *key );
+G_MODULE_EXPORT int set_getint( set_t **head, const char *key );
+G_MODULE_EXPORT int set_getbool( set_t **head, const char *key );
 
 /* set_setstr() strdup()s the given value, so after using this function
    you can free() it, if you want. */
-int set_setstr( set_t **head, char *key, char *value );
-int set_setint( set_t **head, char *key, int value );
-void set_del( set_t **head, char *key );
-int set_reset( set_t **head, char *key );
+int set_setstr( set_t **head, const char *key, char *value );
+int set_setint( set_t **head, const char *key, int value );
+void set_del( set_t **head, const char *key );
+int set_reset( set_t **head, const char *key );
 
 /* Two very useful generic evaluators. */
 char *set_eval_int( set_t *set, char *value );
 char *set_eval_bool( set_t *set, char *value );
+
+/* Another more complicated one. */
+char *set_eval_list( set_t *set, char *value );
 
 /* Some not very generic evaluators that really shouldn't be here... */
Index: storage.c
===================================================================
--- storage.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ storage.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -28,5 +28,4 @@
 #define BITLBEE_CORE
 #include "bitlbee.h"
-#include "crypting.h"
 
 extern storage_t storage_text;
@@ -66,5 +65,4 @@
 	storage_t *storage;
 	
-	register_storage_backend(&storage_text);
 	register_storage_backend(&storage_xml);
 	
Index: storage_xml.c
===================================================================
--- storage_xml.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ storage_xml.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -29,5 +29,4 @@
 #include "arc.h"
 #include "md5.h"
-#include "chat.h"
 
 #if GLIB_CHECK_VERSION(2,8,0)
@@ -55,9 +54,10 @@
 	char *current_setting;
 	account_t *current_account;
-	struct chat *current_chat;
+	irc_channel_t *current_channel;
 	set_t **current_set_head;
 	char *given_nick;
 	char *given_pass;
 	xml_pass_st pass_st;
+	int unknown_tag;
 };
 
@@ -87,5 +87,9 @@
 	irc_t *irc = xd->irc;
 	
-	if( g_strcasecmp( element_name, "user" ) == 0 )
+	if( xd->unknown_tag > 0 )
+	{
+		xd->unknown_tag ++;
+	}
+	else if( g_strcasecmp( element_name, "user" ) == 0 )
 	{
 		char *nick = xml_attr( attr_names, attr_values, "nick" );
@@ -123,5 +127,5 @@
 	else if( g_strcasecmp( element_name, "account" ) == 0 )
 	{
-		char *protocol, *handle, *server, *password = NULL, *autoconnect;
+		char *protocol, *handle, *server, *password = NULL, *autoconnect, *tag;
 		char *pass_b64 = NULL;
 		unsigned char *pass_cr = NULL;
@@ -133,4 +137,5 @@
 		server = xml_attr( attr_names, attr_values, "server" );
 		autoconnect = xml_attr( attr_names, attr_values, "autoconnect" );
+		tag = xml_attr( attr_names, attr_values, "tag" );
 		
 		protocol = xml_attr( attr_names, attr_values, "protocol" );
@@ -147,9 +152,11 @@
 		                         arc_decode( pass_cr, pass_len, &password, xd->given_pass ) )
 		{
-			xd->current_account = account_add( irc, prpl, handle, password );
+			xd->current_account = account_add( irc->b, prpl, handle, password );
 			if( server )
 				set_setstr( &xd->current_account->set, "server", server );
 			if( autoconnect )
 				set_setstr( &xd->current_account->set, "auto_connect", autoconnect );
+			if( tag )
+				set_setstr( &xd->current_account->set, "tag", tag );
 		}
 		else
@@ -176,10 +183,10 @@
 		if( ( setting = xml_attr( attr_names, attr_values, "name" ) ) )
 		{
-			if( xd->current_chat != NULL )
-				xd->current_set_head = &xd->current_chat->set;
+			if( xd->current_channel != NULL )
+				xd->current_set_head = &xd->current_channel->set;
 			else if( xd->current_account != NULL )
 				xd->current_set_head = &xd->current_account->set;
 			else
-				xd->current_set_head = &xd->irc->set;
+				xd->current_set_head = &xd->irc->b->set;
 			
 			xd->current_setting = g_strdup( setting );
@@ -198,5 +205,5 @@
 		if( xd->current_account && handle && nick )
 		{
-			nick_set( xd->current_account, handle, nick );
+			nick_set_raw( xd->current_account, handle, nick );
 		}
 		else
@@ -206,4 +213,28 @@
 		}
 	}
+	else if( g_strcasecmp( element_name, "channel" ) == 0 )
+	{
+		char *name, *type;
+		
+		name = xml_attr( attr_names, attr_values, "name" );
+		type = xml_attr( attr_names, attr_values, "type" );
+		
+		if( !name || !type )
+		{
+			g_set_error( error, G_MARKUP_ERROR, G_MARKUP_ERROR_INVALID_CONTENT,
+			             "Missing attributes for %s element", element_name );
+			return;
+		}
+		
+		/* The channel may exist already, for example if it's &bitlbee.
+		   Also, it's possible that the user just reconnected and the
+		   IRC client already rejoined all channels it was in. They
+		   should still get the right settings. */
+		if( ( xd->current_channel = irc_channel_by_name( irc, name ) ) ||
+		    ( xd->current_channel = irc_channel_new( irc, name ) ) )
+			set_setstr( &xd->current_channel->set, "type", type );
+	}
+	/* Backward compatibility: Keep this around for a while for people
+	   switching from BitlBee 1.2.4+. */
 	else if( g_strcasecmp( element_name, "chat" ) == 0 )
 	{
@@ -215,5 +246,17 @@
 		if( xd->current_account && handle && channel )
 		{
-			xd->current_chat = chat_add( xd->irc, xd->current_account, handle, channel );
+			irc_channel_t *ic;
+			
+			if( ( ic = irc_channel_new( irc, channel ) ) &&
+			    set_setstr( &ic->set, "type", "chat" ) &&
+			    set_setstr( &ic->set, "chat_type", "room" ) &&
+			    set_setstr( &ic->set, "account", xd->current_account->tag ) &&
+			    set_setstr( &ic->set, "room", handle ) )
+			{
+				/* Try to pick up some settings where possible. */
+				xd->current_channel = ic;
+			}
+			else if( ic )
+				irc_channel_free( ic );
 		}
 		else
@@ -225,6 +268,13 @@
 	else
 	{
+		xd->unknown_tag ++;
+		irc_usermsg( irc, "Warning: Unknown XML tag found in configuration file (%s). "
+		                  "This may happen when downgrading BitlBee versions. "
+		                  "This tag will be skipped and the information will be lost "
+		                  "once you save your settings.", element_name );
+		/*
 		g_set_error( error, G_MARKUP_ERROR, G_MARKUP_ERROR_UNKNOWN_ELEMENT,
 		             "Unkown element: %s", element_name );
+		*/
 	}
 }
@@ -234,5 +284,9 @@
 	struct xml_parsedata *xd = data;
 	
-	if( g_strcasecmp( element_name, "setting" ) == 0 && xd->current_setting )
+	if( xd->unknown_tag > 0 )
+	{
+		xd->unknown_tag --;
+	}
+	else if( g_strcasecmp( element_name, "setting" ) == 0 && xd->current_setting )
 	{
 		g_free( xd->current_setting );
@@ -243,7 +297,8 @@
 		xd->current_account = NULL;
 	}
-	else if( g_strcasecmp( element_name, "chat" ) == 0 )
-	{
-		xd->current_chat = NULL;
+	else if( g_strcasecmp( element_name, "channel" ) == 0 ||
+	         g_strcasecmp( element_name, "chat" ) == 0 )
+	{
+		xd->current_channel = NULL;
 	}
 }
@@ -353,5 +408,5 @@
 static storage_status_t xml_load( irc_t *irc, const char *password )
 {
-	return xml_load_real( irc, irc->nick, password, XML_PASS_UNKNOWN );
+	return xml_load_real( irc, irc->user->nick, password, XML_PASS_UNKNOWN );
 }
 
@@ -395,6 +450,7 @@
 	md5_byte_t pass_md5[21];
 	md5_state_t md5_state;
-	
-	path2 = g_strdup( irc->nick );
+	GSList *l;
+	
+	path2 = g_strdup( irc->user->nick );
 	nick_lc( path2 );
 	g_snprintf( path, sizeof( path ) - 2, "%s%s%s", global.conf->configdir, path2, ".xml" );
@@ -404,6 +460,6 @@
 		return STORAGE_ALREADY_EXISTS;
 	
-	strcat( path, "~" );
-	if( ( fd = open( path, O_WRONLY | O_CREAT | O_TRUNC, 0600 ) ) < 0 )
+	strcat( path, ".XXXXXX" );
+	if( ( fd = mkstemp( path ) ) < 0 )
 	{
 		irc_usermsg( irc, "Error while opening configuration file." );
@@ -422,20 +478,19 @@
 	pass_buf = base64_encode( pass_md5, 21 );
 	
-	if( !xml_printf( fd, 0, "<user nick=\"%s\" password=\"%s\" version=\"%d\">\n", irc->nick, pass_buf, XML_FORMAT_VERSION ) )
+	if( !xml_printf( fd, 0, "<user nick=\"%s\" password=\"%s\" version=\"%d\">\n", irc->user->nick, pass_buf, XML_FORMAT_VERSION ) )
 		goto write_error;
 	
 	g_free( pass_buf );
 	
-	for( set = irc->set; set; set = set->next )
+	for( set = irc->b->set; set; set = set->next )
 		if( set->value )
 			if( !xml_printf( fd, 1, "<setting name=\"%s\">%s</setting>\n", set->key, set->value ) )
 				goto write_error;
 	
-	for( acc = irc->accounts; acc; acc = acc->next )
+	for( acc = irc->b->accounts; acc; acc = acc->next )
 	{
 		unsigned char *pass_cr;
 		char *pass_b64;
 		int pass_len;
-		struct chat *c;
 		
 		pass_len = arc_encode( acc->pass, strlen( acc->pass ), (unsigned char**) &pass_cr, irc->password, 12 );
@@ -443,5 +498,7 @@
 		g_free( pass_cr );
 		
-		if( !xml_printf( fd, 1, "<account protocol=\"%s\" handle=\"%s\" password=\"%s\" autoconnect=\"%d\"", acc->prpl->name, acc->user, pass_b64, acc->auto_connect ) )
+		if( !xml_printf( fd, 1, "<account protocol=\"%s\" handle=\"%s\" password=\"%s\" "
+		                        "autoconnect=\"%d\" tag=\"%s\"", acc->prpl->name, acc->user,
+		                        pass_b64, acc->auto_connect, acc->tag ) )
 		{
 			g_free( pass_b64 );
@@ -470,33 +527,35 @@
 			goto write_error;
 		
-		for( c = irc->chatrooms; c; c = c->next )
-		{
-			if( c->acc != acc )
-				continue;
-			
-			if( !xml_printf( fd, 2, "<chat handle=\"%s\" channel=\"%s\" type=\"%s\">\n",
-			                        c->handle, c->channel, "room" ) )
-				goto write_error;
-			
-			for( set = c->set; set; set = set->next )
-				if( set->value && !( set->flags & ACC_SET_NOSAVE ) )
-					if( !xml_printf( fd, 3, "<setting name=\"%s\">%s</setting>\n",
-					                        set->key, set->value ) )
-						goto write_error;
-
-			if( !xml_printf( fd, 2, "</chat>\n" ) )
-				goto write_error;
-		}
-		
 		if( !xml_printf( fd, 1, "</account>\n" ) )
 			goto write_error;
 	}
 	
+	for( l = irc->channels; l; l = l->next )
+	{
+		irc_channel_t *ic = l->data;
+		
+		if( ic->flags & IRC_CHANNEL_TEMP )
+			continue;
+		
+		if( !xml_printf( fd, 1, "<channel name=\"%s\" type=\"%s\">\n",
+		                 ic->name, set_getstr( &ic->set, "type" ) ) )
+			goto write_error;
+		
+		for( set = ic->set; set; set = set->next )
+			if( set->value && strcmp( set->key, "type" ) != 0 )
+				if( !xml_printf( fd, 2, "<setting name=\"%s\">%s</setting>\n", set->key, set->value ) )
+					goto write_error;
+		
+		if( !xml_printf( fd, 1, "</channel>\n" ) )
+			goto write_error;
+	}
+	
 	if( !xml_printf( fd, 0, "</user>\n" ) )
 		goto write_error;
 	
+	fsync( fd );
 	close( fd );
 	
-	path2 = g_strndup( path, strlen( path ) - 1 );
+	path2 = g_strndup( path, strlen( path ) - 7 );
 	if( rename( path, path2 ) != 0 )
 	{
Index: tests/Makefile
===================================================================
--- tests/Makefile	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ tests/Makefile	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -1,3 +1,6 @@
 -include ../Makefile.settings
+ifdef SRCDIR
+SRCDIR := $(SRCDIR)tests/
+endif
 
 LFLAGS +=-lcheck
@@ -11,7 +14,7 @@
 distclean: clean
 
-main_objs = account.o bitlbee.o chat.o conf.o crypting.o help.o ipc.o irc.o irc_commands.o log.o nick.o query.o root_commands.o set.o storage.o storage_xml.o storage_text.o user.o
+main_objs = bitlbee.o conf.o dcc.o help.o ipc.o irc.o irc_channel.o irc_commands.o irc_im.o irc_send.o irc_user.o irc_util.o irc_commands.o log.o nick.o query.o root_commands.o set.o storage.o storage_xml.o
 
-test_objs = check.o check_util.o check_nick.o check_md5.o check_arc.o check_irc.o check_help.o check_user.o check_crypting.o check_set.o check_jabber_sasl.o check_jabber_util.o
+test_objs = check.o check_util.o check_nick.o check_md5.o check_arc.o check_irc.o check_help.o check_user.o check_set.o check_jabber_sasl.o check_jabber_util.o
 
 check: $(test_objs) $(addprefix ../, $(main_objs)) ../protocols/protocols.o ../lib/lib.o
@@ -19,5 +22,5 @@
 	@$(CC) $(CFLAGS) -o $@ $^ $(LFLAGS) $(EFLAGS)
 
-%.o: %.c
+%.o: $(SRCDIR)%.c
 	@echo '*' Compiling $<
 	@$(CC) -c $(CFLAGS) $< -o $@
Index: tests/check.c
===================================================================
--- tests/check.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ tests/check.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -3,4 +3,5 @@
 #include <gmodule.h>
 #include <check.h>
+#include <locale.h>
 #include "bitlbee.h"
 #include "testsuite.h"
@@ -60,7 +61,4 @@
 Suite *user_suite(void);
 
-/* From check_crypting.c */
-Suite *crypting_suite(void);
-
 /* From check_set.c */
 Suite *set_suite(void);
@@ -95,4 +93,6 @@
 
 	log_init();
+	b_main_init();
+	setlocale(LC_CTYPE, "");
 
 	if (verbose) {
@@ -115,5 +115,4 @@
 	srunner_add_suite(sr, help_suite());
 	srunner_add_suite(sr, user_suite());
-	srunner_add_suite(sr, crypting_suite());
 	srunner_add_suite(sr, set_suite());
 	srunner_add_suite(sr, jabber_sasl_suite());
Index: tests/check_user.c
===================================================================
--- tests/check_user.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ tests/check_user.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -5,7 +5,7 @@
 #include <string.h>
 #include "bitlbee.h"
-#include "user.h"
 #include "testsuite.h"
 
+#if 0
 START_TEST(test_user_add)
 	irc_t *irc = torture_irc();
@@ -59,5 +59,5 @@
 	fail_if(user_find(irc, "bar") == NULL);
 END_TEST
-
+#endif
 Suite *user_suite (void)
 {
@@ -65,4 +65,5 @@
 	TCase *tc_core = tcase_create("Core");
 	suite_add_tcase (s, tc_core);
+#if 0
 	tcase_add_test (tc_core, test_user_add);
 	tcase_add_test (tc_core, test_user_add_invalid);
@@ -72,4 +73,5 @@
 	tcase_add_test (tc_core, test_user_del);
 	tcase_add_test (tc_core, test_user_rename);
+#endif
 	return s;
 }
Index: tests/check_util.c
===================================================================
--- tests/check_util.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ tests/check_util.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -161,4 +161,12 @@
 END_TEST
 
+START_TEST(test_http_encode)
+	char s[80];
+	
+	strcpy( s, "ee\xc3""\xab""ee!!..." );
+	http_encode( s );
+	fail_unless( strcmp( s, "ee%C3%ABee%21%21..." ) == 0 );
+END_TEST
+
 Suite *util_suite (void)
 {
@@ -174,4 +182,5 @@
 	tcase_add_test (tc_core, test_set_url_username_pwd);
 	tcase_add_test (tc_core, test_word_wrap);
+	tcase_add_test (tc_core, test_http_encode);
 	return s;
 }
Index: unix.c
===================================================================
--- unix.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ unix.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -39,4 +39,5 @@
 #include <sys/wait.h>
 #include <pwd.h>
+#include <locale.h>
 
 global_t global;	/* Against global namespace pollution */
@@ -52,8 +53,13 @@
 	struct sigaction sig, old;
 	
+	/* Required to make iconv to ASCII//TRANSLIT work. This makes BitlBee
+	   system-locale-sensitive. :-( */
+	setlocale( LC_CTYPE, "" );
+	
 	if( argc > 1 && strcmp( argv[1], "-x" ) == 0 )
 		return crypt_main( argc, argv );
 	
 	log_init();
+	
 	global.conf_file = g_strdup( CONF_FILE_DEF );
 	global.conf = conf_load( argc, argv );
@@ -62,8 +68,17 @@
 	
 	b_main_init();
-	nogaim_init();
 	
 	srand( time( NULL ) ^ getpid() );
+	
 	global.helpfile = g_strdup( HELP_FILE );
+	if( help_init( &global.help, global.helpfile ) == NULL )
+		log_message( LOGLVL_WARNING, "Error opening helpfile %s.", HELP_FILE );
+
+	global.storage = storage_init( global.conf->primary_storage, global.conf->migrate_storage );
+	if( global.storage == NULL )
+	{
+		log_message( LOGLVL_ERROR, "Unable to load storage backend '%s'", global.conf->primary_storage );
+		return( 1 );
+	}
 	
 	if( global.conf->runmode == RUNMODE_INETD )
@@ -73,17 +88,20 @@
 	
 		i = bitlbee_inetd_init();
-		log_message( LOGLVL_INFO, "Bitlbee %s starting in inetd mode.", BITLBEE_VERSION );
+		log_message( LOGLVL_INFO, "BitlBee %s starting in inetd mode.", BITLBEE_VERSION );
 
 	}
 	else if( global.conf->runmode == RUNMODE_DAEMON )
 	{
-		log_link( LOGLVL_ERROR, LOGOUTPUT_SYSLOG );
-		log_link( LOGLVL_WARNING, LOGOUTPUT_SYSLOG );
+		log_link( LOGLVL_ERROR, LOGOUTPUT_CONSOLE );
+		log_link( LOGLVL_WARNING, LOGOUTPUT_CONSOLE );
 
 		i = bitlbee_daemon_init();
-		log_message( LOGLVL_INFO, "Bitlbee %s starting in daemon mode.", BITLBEE_VERSION );
+		log_message( LOGLVL_INFO, "BitlBee %s starting in daemon mode.", BITLBEE_VERSION );
 	}
 	else if( global.conf->runmode == RUNMODE_FORKDAEMON )
 	{
+		log_link( LOGLVL_ERROR, LOGOUTPUT_CONSOLE );
+		log_link( LOGLVL_WARNING, LOGOUTPUT_CONSOLE );
+
 		/* In case the operator requests a restart, we need this. */
 		old_cwd = g_malloc( 256 );
@@ -96,5 +114,5 @@
 		
 		i = bitlbee_daemon_init();
-		log_message( LOGLVL_INFO, "Bitlbee %s starting in forking daemon mode.", BITLBEE_VERSION );
+		log_message( LOGLVL_INFO, "BitlBee %s starting in forking daemon mode.", BITLBEE_VERSION );
 	}
 	if( i != 0 )
@@ -113,11 +131,4 @@
 			setuid( pw->pw_uid );
 		}
-	}
-
-	global.storage = storage_init( global.conf->primary_storage, global.conf->migrate_storage );
-	if( global.storage == NULL )
-	{
-		log_message( LOGLVL_ERROR, "Unable to load storage backend '%s'", global.conf->primary_storage );
-		return( 1 );
 	}
  	
@@ -139,6 +150,4 @@
 	if( !getuid() || !geteuid() )
 		log_message( LOGLVL_WARNING, "BitlBee is running with root privileges. Why?" );
-	if( help_init( &global.help, global.helpfile ) == NULL )
-		log_message( LOGLVL_WARNING, "Error opening helpfile %s.", HELP_FILE );
 	
 	b_main_run();
@@ -150,10 +159,13 @@
 	{
 		char *fn = ipc_master_save_state();
+		char *env;
+		
+		env = g_strdup_printf( "_BITLBEE_RESTART_STATE=%s", fn );
+		putenv( env );
+		g_free( fn );
+		/* Looks like env should *not* be freed here as putenv
+		   doesn't make a copy. Odd. */
 		
 		chdir( old_cwd );
-		
-		setenv( "_BITLBEE_RESTART_STATE", fn, 1 );
-		g_free( fn );
-		
 		close( global.listen_socket );
 		
@@ -230,5 +242,5 @@
 	/* FIXME: Calling log_message() here is not a very good idea! */
 	
-	if( signal == SIGTERM )
+	if( signal == SIGTERM || signal == SIGQUIT || signal == SIGINT )
 	{
 		static int first = 1;
Index: win32.c
===================================================================
--- win32.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ win32.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -27,5 +27,4 @@
 #include "bitlbee.h"
 #include "commands.h"
-#include "crypting.h"
 #include "protocols/nogaim.h"
 #include "help.h"
